Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limmsh_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limmsh_2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limmsh_2.F90	(revision 2528)
@@ -4,4 +4,8 @@
    !! LIM 2.0 ice model :   definition of the ice mesh parameters
    !!======================================================================
+   !! History :   -   ! 2001-04 (LIM) original code
+   !!            1.0  ! 2002-08 (C. Ethe, G. Madec) F90, module
+   !!            3.3  ! 2009-05 (G. Garric, C. Bricaud) addition of the lim2_evp case
+   !!----------------------------------------------------------------------
 #if defined key_lim2
    !!----------------------------------------------------------------------
@@ -10,5 +14,4 @@
    !!   lim_msh_2   : definition of the ice mesh
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE phycst
    USE dom_oce
@@ -20,13 +23,11 @@
    PRIVATE
 
-   !! * Accessibility
    PUBLIC lim_msh_2      ! routine called by ice_ini_2.F90
 
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
+   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -43,19 +44,13 @@
       !! 
       !! ** Refer.  : Deleersnijder et al. Ocean Modelling 100, 7-10 
-      !!
-      !! ** History :
-      !!         original    : 01-04 (LIM)
-      !!         addition    : 02-08 (C. Ethe, G. Madec)
       !!--------------------------------------------------------------------- 
-      !! * Local variables
       INTEGER :: ji, jj      ! dummy loop indices
-
-      REAL(wp), DIMENSION(jpi,jpj) ::  &
-         zd2d1 , zd1d2       ! Derivative of zh2 (resp. zh1) in the x direction
-         !                   ! (resp. y direction) (defined at the center)
-      REAL(wp) ::         &
-         zh1p  , zh2p   , &  ! Idem zh1, zh2 for the bottom left corner of the grid
-         zd2d1p, zd1d2p , &  ! Idem zd2d1, zd1d2 for the bottom left corner of the grid
-         zusden, zusden2     ! temporary scalars
+      REAL(wp) ::   zusden   ! local scalars
+#if defined key_lim2_vp
+      REAL(wp) ::   zusden2           ! local scalars
+      REAL(wp) ::   zh1p  , zh2p      !   -      -
+      REAL(wp) ::   zd2d1p, zd1d2p    !   -      -
+      REAL(wp), DIMENSION(jpi,jpj) ::   zd2d1 , zd1d2   ! 2D workspace
+#endif
       !!---------------------------------------------------------------------
 
@@ -76,5 +71,5 @@
       njeqm1 = njeq - 1 
 
-      fcor(:,:) = 2. * omega * SIN( gphit(:,:) * rad )   !  coriolis factor
+      fcor(:,:) = 2. * omega * SIN( gphit(:,:) * rad )   !  coriolis factor at T-point
  
 !i    DO jj = 1, jpj
@@ -115,11 +110,17 @@
       !-------------------
 !!ibug ???
-      akappa(:,:,:,:) = 0.e0
       wght(:,:,:,:) = 0.e0
+      tmu(:,:)      = 0.e0
+#if defined key_lim2_vp 
+      akappa(:,:,:,:)     = 0.e0
       alambd(:,:,:,:,:,:) = 0.e0
-      tmu(:,:) = 0.e0
+#else
+      tmv(:,:) = 0.e0
+      tmf(:,:) = 0.e0
+#endif
 !!i
       
-      
+
+#if defined key_lim2_vp      
       ! metric coefficients for sea ice dynamic
       !----------------------------------------
@@ -155,8 +156,25 @@
       CALL lbc_lnk( wght(:,:,2,1), 'I', 1. )      ! but it is never used
       CALL lbc_lnk( wght(:,:,2,2), 'I', 1. )
+#else
+      ! metric coefficients for sea ice dynamic (EVP rheology)
+      !----------------------------------------
+      DO jj = 1, jpjm1                                       ! weights (wght) at F-points
+         DO ji = 1, jpim1
+            zusden = 1. / (  ( e1t(ji+1,jj  ) + e1t(ji,jj) )   &
+               &           * ( e2t(ji  ,jj+1) + e2t(ji,jj) ) ) 
+            wght(ji,jj,1,1) = zusden * e1t(ji+1,jj) * e2t(ji,jj+1)
+            wght(ji,jj,1,2) = zusden * e1t(ji+1,jj) * e2t(ji,jj  )
+            wght(ji,jj,2,1) = zusden * e1t(ji  ,jj) * e2t(ji,jj+1)
+            wght(ji,jj,2,2) = zusden * e1t(ji  ,jj) * e2t(ji,jj  )
+         END DO
+      END DO
+      CALL lbc_lnk( wght(:,:,1,1), 'F', 1. )   ;   CALL lbc_lnk( wght(:,:,1,2),'F', 1. )       ! lateral boundary cond.   
+      CALL lbc_lnk( wght(:,:,2,1), 'F', 1. )   ;   CALL lbc_lnk( wght(:,:,2,2),'F', 1. )
+#endif
     
       ! Coefficients for divergence of the stress tensor
       !-------------------------------------------------
 
+#if defined key_lim2_vp
       DO jj = 2, jpj
          DO ji = 2, jpi   ! NO vector opt.
@@ -226,4 +244,5 @@
       CALL lbc_lnk( alambd(:,:,2,1,1,1), 'I', 1. )      !
       CALL lbc_lnk( alambd(:,:,2,1,1,2), 'I', 1. )      !
+#endif
             
 
@@ -233,4 +252,6 @@
       tms(:,:) = tmask(:,:,1)      ! ice T-point  : use surface tmask
 
+#if defined key_lim2_vp
+      ! VP rheology : ice velocity point is I-point
 !i here we can use umask with a i and j shift of -1,-1
       tmu(:,1) = 0.e0
@@ -241,11 +262,17 @@
          END DO
       END DO
-      
-      !--lateral boundary conditions    
-      CALL lbc_lnk( tmu(:,:), 'I', 1. )
-      
+      CALL lbc_lnk( tmu(:,:), 'I', 1. )      !--lateral boundary conditions    
+#else
+      ! EVP rheology : ice velocity point are U- & V-points ; ice vorticity
+      ! point is F-point
+      tmu(:,:) = umask(:,:,1)
+      tmv(:,:) = vmask(:,:,1)
+      tmf(:,:) = 0.e0                        ! used of fmask except its special value along the coast (rn_shlat)
+      WHERE( fmask(:,:,1) == 1.e0 )   tmf(:,:) = 1.e0
+#endif
+      !
       ! unmasked and masked area of T-grid cell
       area(:,:) = e1t(:,:) * e2t(:,:)
-      
+      !
    END SUBROUTINE lim_msh_2
 
Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limrhg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limrhg.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limrhg.F90	(revision 2528)
@@ -0,0 +1,1 @@
+link ../LIM_SRC_3/limrhg.F90
Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limrhg_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 2528)
@@ -4,14 +4,15 @@
    !!   Ice rheology :  performs sea ice rheology
    !!======================================================================
-   !! History :  0.0  !  93-12  (M.A. Morales Maqueda.)  Original code
-   !!            1.0  !  94-12  (H. Goosse) 
-   !!            2.0  !  03-12  (C. Ethe, G. Madec)  F90, mpp
-   !!            " "  !  06-08  (G. Madec)  surface module, ice-stress at I-point
-   !!            " "  !  09-09  (G. Madec)  Huge verctor optimisation
-   !!----------------------------------------------------------------------
-#if defined key_lim2
-   !!----------------------------------------------------------------------
-   !!   'key_lim2'                                    LIM 2.0 sea-ice model
-   !!----------------------------------------------------------------------
+   !! History :  0.0  !  1993-12  (M.A. Morales Maqueda.)  Original code
+   !!            1.0  !  1994-12  (H. Goosse) 
+   !!            2.0  !  2003-12  (C. Ethe, G. Madec)  F90, mpp
+   !!             -   !  2006-08  (G. Madec)  surface module, ice-stress at I-point
+   !!             -   !  2009-09  (G. Madec)  Huge verctor optimisation
+   !!            3.3  !  2009-05  (G.Garric, C. Bricaud) addition of the lim2_evp case
+   !!----------------------------------------------------------------------
+#if defined   key_lim2   &&   defined key_lim2_vp
+   !!----------------------------------------------------------------------
+   !!   'key_lim2'                AND                   LIM-2 sea-ice model
+   !!   'key_lim2_vp'                                       VP ice rheology
    !!----------------------------------------------------------------------
    !!   lim_rhg_2   : computes ice velocities
@@ -21,8 +22,8 @@
    USE sbc_oce        ! surface boundary condition: ocean variables
    USE sbc_ice        ! surface boundary condition: ice variables
-   USE dom_ice_2      ! domaine: ice variables
+   USE dom_ice_2      ! LIM2: ice domain
    USE phycst         ! physical constant
-   USE ice_2          ! ice variables
-   USE lbclnk         ! lateral boundary condition
+   USE ice_2          ! LIM2: ice variables
+   USE lbclnk         ! lateral boundary condition - MPP exchanges
    USE lib_mpp        ! MPP library
    USE in_out_manager ! I/O manager
@@ -34,15 +35,14 @@
    PUBLIC   lim_rhg_2 ! routine called by lim_dyn
 
-   REAL(wp) ::   rzero   = 0.e0   ! constant value: zero
-   REAL(wp) ::   rone    = 1.e0   !            and  one
+   REAL(wp) ::   rzero   = 0._wp   ! constant value: zero
+   REAL(wp) ::   rone    = 1._wp   !            and  one
 
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
+   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -65,9 +65,9 @@
       INTEGER ::   iter, jter          ! temporary integers
       CHARACTER (len=50) ::   charout
-      REAL(wp) ::   ze11  , ze12  , ze22  , ze21               ! temporary scalars
-      REAL(wp) ::   zt11  , zt12  , zt21  , zt22               !    "         "
-      REAL(wp) ::   zvis11, zvis21, zvis12, zvis22             !    "         "
-      REAL(wp) ::   zgphsx, ztagnx, zgsshx, zunw, zur, zusw    !    "         "
-      REAL(wp) ::   zgphsy, ztagny, zgsshy, zvnw, zvr          !    "         "
+      REAL(wp) ::   ze11  , ze12  , ze22  , ze21               ! local scalars
+      REAL(wp) ::   zt11  , zt12  , zt21  , zt22               !   -      -
+      REAL(wp) ::   zvis11, zvis21, zvis12, zvis22             !   -      -
+      REAL(wp) ::   zgphsx, ztagnx, zgsshx, zunw, zur, zusw    !   -      -
+      REAL(wp) ::   zgphsy, ztagny, zgsshy, zvnw, zvr          !   -      -
       REAL(wp) ::   zresm,  za, zac, zmod
       REAL(wp) ::   zmpzas, zstms, zindu, zusdtp, zmassdt, zcorlal
@@ -89,45 +89,37 @@
       REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zzfrld, zztms
       REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zi1, zi2, zmasst, zpresh
-
       !!-------------------------------------------------------------------
-
-!!bug
-!!    u_oce(:,:) = 0.e0
-!!    v_oce(:,:) = 0.e0
-!!    write(*,*) 'rhg min, max u & v', maxval(u_oce), minval(u_oce), maxval(v_oce), minval(v_oce)
-!!bug
       
       !  Store initial velocities
       !  ----------------
-      zztms(:,0    ) = 0.e0       ;    zzfrld(:,0    ) = 0.e0
-      zztms(:,jpj+1) = 0.e0       ;    zzfrld(:,jpj+1) = 0.e0
-      zu0(:,0    ) = 0.e0         ;    zv0(:,0    ) = 0.e0
-      zu0(:,jpj+1) = 0.e0         ;    zv0(:,jpj+1) = 0.e0
-      zztms(:,1:jpj) = tms(:,:)   ;    zzfrld(:,1:jpj) = frld(:,:)
-      zu0(:,1:jpj) = u_ice(:,:)   ;    zv0(:,1:jpj) = v_ice(:,:)
-
-      zu_a(:,:)    = zu0(:,:)     ;   zv_a(:,:) = zv0(:,:)
-      zu_n(:,:)    = zu0(:,:)     ;   zv_n(:,:) = zv0(:,:)
+      zztms(:,0    ) = 0._wp        ;   zzfrld(:,0    ) = 0._wp
+      zztms(:,jpj+1) = 0._wp        ;   zzfrld(:,jpj+1) = 0._wp
+      zu0  (:,0    ) = 0._wp        ;   zv0   (:,0    ) = 0._wp
+      zu0  (:,jpj+1) = 0._wp        ;   zv0   (:,jpj+1) = 0._wp
+      zztms(:,1:jpj) = tms  (:,:)   ;   zzfrld(:,1:jpj) = frld (:,:)
+      zu0  (:,1:jpj) = u_ice(:,:)   ;   zv0   (:,1:jpj) = v_ice(:,:)
+      zu_a (:, :   ) = zu0  (:,:)   ;   zv_a  (:, :   ) = zv0  (:,:)
+      zu_n (:, :   ) = zu0  (:,:)   ;   zv_n  (:, :   ) = zv0  (:,:)
 
 !i
-      zi1   (:,:) = 0.e0
-      zi2   (:,:) = 0.e0
-      zpresh(:,:) = 0.e0
-      zmasst(:,:) = 0.e0
+      zi1   (:,:) = 0._wp
+      zi2   (:,:) = 0._wp
+      zpresh(:,:) = 0._wp
+      zmasst(:,:) = 0._wp
 !i
 !!gm violant
-      zfrld(:,:) =0.e0
-      zcorl(:,:) =0.e0
-      zmass(:,:) =0.e0
-      za1ct(:,:) =0.e0
-      za2ct(:,:) =0.e0
+      zfrld(:,:) =0._wp
+      zcorl(:,:) =0._wp
+      zmass(:,:) =0._wp
+      za1ct(:,:) =0._wp
+      za2ct(:,:) =0._wp
 !!gm end
 
-      zviszeta(:,:) = 0.e0
-      zviseta (:,:) = 0.e0
-
-!i    zviszeta(:,0    ) = 0.e0    ;    zviseta(:,0    ) = 0.e0
-!i    zviszeta(:,jpj  ) = 0.e0    ;    zviseta(:,jpj  ) = 0.e0
-!i    zviszeta(:,jpj+1) = 0.e0    ;    zviseta(:,jpj+1) = 0.e0
+      zviszeta(:,:) = 0._wp
+      zviseta (:,:) = 0._wp
+
+!i    zviszeta(:,0    ) = 0._wp    ;    zviseta(:,0    ) = 0._wp
+!i    zviszeta(:,jpj  ) = 0._wp    ;    zviseta(:,jpj  ) = 0._wp
+!i    zviszeta(:,jpj+1) = 0._wp    ;    zviseta(:,jpj+1) = 0._wp
 
 
@@ -141,11 +133,11 @@
          DO ji = 1 , jpi
             ! only the sinus changes its sign with the hemisphere
-            zsang(ji,jj)  = SIGN( 1.e0, fcor(ji,jj) ) * sangvg   ! only the sinus changes its sign with the hemisphere
+            zsang(ji,jj)  = SIGN( 1._wp, fcor(ji,jj) ) * sangvg   ! only the sinus changes its sign with the hemisphere
             !
             zmasst(ji,jj) = tms(ji,jj) * ( rhosn * hsnm(ji,jj) + rhoic * hicm(ji,jj) )
             zpresh(ji,jj) = tms(ji,jj) *  pstarh * hicm(ji,jj) * EXP( -c_rhg * frld(ji,jj) )
 !!gm  :: stress given at I-point (F-point for the ocean) only compute the ponderation with the ice fraction (1-frld)
-            zi1(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
-            zi2(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
+            zi1(ji,jj)    = tms(ji,jj) * ( 1._wp - frld(ji,jj) )
+            zi2(ji,jj)    = tms(ji,jj) * ( 1._wp - frld(ji,jj) )
          END DO
       END DO
@@ -161,5 +153,5 @@
             zstms = zztms(ji,jj  ) * wght(ji,jj,2,2) + zztms(ji-1,jj  ) * wght(ji,jj,1,2)   &
                &  + zztms(ji,jj-1) * wght(ji,jj,2,1) + zztms(ji-1,jj-1) * wght(ji,jj,1,1)
-            zusw  = 1.0 / MAX( zstms, epsd )
+            zusw  = 1._wp / MAX( zstms, epsd )
 
             zt11 = zztms(ji  ,jj  ) * zzfrld(ji  ,jj  ) 
@@ -199,7 +191,7 @@
             ! Gradient of the sea surface height
             zgsshx =  (   (ssh_m(ji  ,jj  ) - ssh_m(ji-1,jj  ))/e1u(ji-1,jj  )   &
-               &       +  (ssh_m(ji  ,jj-1) - ssh_m(ji-1,jj-1))/e1u(ji-1,jj-1)   ) * 0.5
+               &       +  (ssh_m(ji  ,jj-1) - ssh_m(ji-1,jj-1))/e1u(ji-1,jj-1)   ) * 0.5_wp
             zgsshy =  (   (ssh_m(ji  ,jj  ) - ssh_m(ji  ,jj-1))/e2v(ji  ,jj-1)   &
-               &       +  (ssh_m(ji-1,jj  ) - ssh_m(ji-1,jj-1))/e2v(ji-1,jj-1)   ) * 0.5
+               &       +  (ssh_m(ji-1,jj  ) - ssh_m(ji-1,jj-1))/e2v(ji-1,jj-1)   ) * 0.5_wp
 
             ! Computation of the velocity field taking into account the ice-ice interaction.                                 
@@ -217,5 +209,5 @@
          !                                                ! ==================== !        
          zindu = MOD( iter , 2 )
-         zusdtp = ( zindu * 2.0 + ( 1.0 - zindu ) * 1.0 )  * REAL( nbiter ) / rdt_ice
+         zusdtp = ( zindu * 2._wp + ( 1._wp - zindu ) * 1._wp )  * REAL( nbiter ) / rdt_ice
 
          ! Computation of free drift field for free slip boundary conditions.
@@ -239,8 +231,8 @@
                zdgi = zt12 + zt21
                ztrace2 = zdgp * zdgp 
-               zdeter  = zt11 * zt22 - 0.25 * zdgi * zdgi
+               zdeter  = zt11 * zt22 - 0.25_wp * zdgi * zdgi
 
                !  Creep limit depends on the size of the grid.
-               zdelta = MAX( SQRT( ztrace2 + ( ztrace2 - 4.0 * zdeter ) * usecc2 ),  creepl)
+               zdelta = MAX( SQRT( ztrace2 + ( ztrace2 - 4._wp * zdeter ) * usecc2 ),  creepl)
 
                !-  Computation of viscosities.
@@ -254,8 +246,8 @@
             DO ji = 2, fs_jpim1   ! NO vector opt.
                !* zc1u , zc2v
-               zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
-               zvis12 =       zviseta (ji-1,jj-1) + dm
-               zvis21 =       zviseta (ji-1,jj-1)
-               zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
+               zvis11 = 2._wp * zviseta (ji-1,jj-1) + dm
+               zvis12 =         zviseta (ji-1,jj-1) + dm
+               zvis21 =         zviseta (ji-1,jj-1)
+               zvis22 =         zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
                zdiag  = zvis22 * ( akappa(ji-1,jj-1,1,1) + akappa(ji-1,jj-1,2,1) )
                zs11_11 =  zvis11 * akappa(ji-1,jj-1,1,1) + zdiag
@@ -264,8 +256,8 @@
                zs22_11 =  zvis11 * akappa(ji-1,jj-1,2,1) + zdiag
 
-               zvis11 = 2.0 * zviseta (ji,jj-1) + dm
-               zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
-               zvis12 =       zviseta (ji,jj-1) + dm
-               zvis21 =       zviseta (ji,jj-1)
+               zvis11 = 2._wp * zviseta (ji,jj-1) + dm
+               zvis22 =         zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+               zvis12 =         zviseta (ji,jj-1) + dm
+               zvis21 =         zviseta (ji,jj-1)
                zdiag = zvis22 * ( -akappa(ji,jj-1,1,1) + akappa(ji,jj-1,2,1) )
                zs11_21 = -zvis11 * akappa(ji,jj-1,1,1) + zdiag
@@ -274,9 +266,9 @@
                zs21_21 = -zvis12 * akappa(ji,jj-1,1,2) + zvis21 * akappa(ji,jj-1,2,2)
 
-               zvis11 = 2.0 * zviseta (ji-1,jj) + dm
-               zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
-               zvis12 =       zviseta (ji-1,jj) + dm
-               zvis21 =       zviseta (ji-1,jj)
-               zdiag = zvis22 * ( akappa(ji-1,jj,1,1) + akappa(ji-1,jj,2,1) )
+               zvis11 = 2._wp * zviseta (ji-1,jj) + dm
+               zvis22 =         zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+               zvis12 =         zviseta (ji-1,jj) + dm
+               zvis21 =         zviseta (ji-1,jj)
+               zdiag  = zvis22 * ( akappa(ji-1,jj,1,1) + akappa(ji-1,jj,2,1) )
                zs11_12 =  zvis11 * akappa(ji-1,jj,1,1) + zdiag
                zs12_12 = -zvis12 * akappa(ji-1,jj,2,2) - zvis21 * akappa(ji-1,jj,1,2)
@@ -284,8 +276,8 @@
                zs21_12 = -zvis12 * akappa(ji-1,jj,1,2) - zvis21 * akappa(ji-1,jj,2,2)
 
-               zvis11 = 2.0 * zviseta (ji,jj) + dm
-               zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
-               zvis12 =       zviseta (ji,jj) + dm
-               zvis21 =       zviseta (ji,jj)
+               zvis11 = 2._wp * zviseta (ji,jj) + dm
+               zvis22 =         zviszeta(ji,jj) - zviseta(ji,jj)
+               zvis12 =         zviseta (ji,jj) + dm
+               zvis21 =         zviseta (ji,jj)
                zdiag = zvis22 * ( -akappa(ji,jj,1,1) + akappa(ji,jj,2,1) )
                zs11_22 = -zvis11 * akappa(ji,jj,1,1) + zdiag
@@ -313,8 +305,8 @@
 
                !* zc1v , zc2v.
-               zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
-               zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
-               zvis12 =       zviseta (ji-1,jj-1) + dm
-               zvis21 =       zviseta (ji-1,jj-1)
+               zvis11 = 2._wp * zviseta (ji-1,jj-1) + dm
+               zvis22 =         zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
+               zvis12 =         zviseta (ji-1,jj-1) + dm
+               zvis21 =         zviseta (ji-1,jj-1)
                zdiag = zvis22 * ( akappa(ji-1,jj-1,1,2) + akappa(ji-1,jj-1,2,2) )
                zs11_11 =  zvis11 * akappa(ji-1,jj-1,1,2) + zdiag
@@ -323,8 +315,8 @@
                zs21_11 =  zvis12 * akappa(ji-1,jj-1,1,1) - zvis21 * akappa(ji-1,jj-1,2,1)
  
-               zvis11 = 2.0 * zviseta (ji,jj-1) + dm
-               zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
-               zvis12 =       zviseta (ji,jj-1) + dm
-               zvis21 =       zviseta (ji,jj-1)
+               zvis11 = 2._wp * zviseta (ji,jj-1) + dm
+               zvis22 =         zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+               zvis12 =         zviseta (ji,jj-1) + dm
+               zvis21 =         zviseta (ji,jj-1)
                zdiag = zvis22 * ( akappa(ji,jj-1,1,2) + akappa(ji,jj-1,2,2) )
                zs11_21 =  zvis11 * akappa(ji,jj-1,1,2) + zdiag
@@ -333,8 +325,8 @@
                zs21_21 = -zvis12 * akappa(ji,jj-1,1,1) - zvis21 * akappa(ji,jj-1,2,1)
 
-               zvis11 = 2.0 * zviseta (ji-1,jj) + dm
-               zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
-               zvis12 =       zviseta (ji-1,jj) + dm
-               zvis21 =       zviseta (ji-1,jj)
+               zvis11 = 2._wp * zviseta (ji-1,jj) + dm
+               zvis22 =         zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+               zvis12 =         zviseta (ji-1,jj) + dm
+               zvis21 =         zviseta (ji-1,jj)
                zdiag = zvis22 * ( akappa(ji-1,jj,1,2) - akappa(ji-1,jj,2,2) )
                zs11_12 =  zvis11 * akappa(ji-1,jj,1,2) + zdiag
@@ -343,8 +335,8 @@
                zs21_12 =  zvis12 * akappa(ji-1,jj,1,1) - zvis21 * akappa(ji-1,jj,2,1)
 
-               zvis11 = 2.0 * zviseta (ji,jj) + dm
-               zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
-               zvis12 =       zviseta (ji,jj) + dm
-               zvis21 =       zviseta (ji,jj)
+               zvis11 = 2._wp * zviseta (ji,jj) + dm
+               zvis22 =         zviszeta(ji,jj) - zviseta(ji,jj)
+               zvis12 =         zviseta (ji,jj) + dm
+               zvis21 =         zviseta (ji,jj)
                zdiag = zvis22 * ( akappa(ji,jj,1,2) - akappa(ji,jj,2,2) )
                zs11_22 =  zvis11 * akappa(ji,jj,1,2) + zdiag
@@ -386,8 +378,8 @@
                   ze22 = + akappa(ji,jj-1,2,2) * zv_a(ji+1,jj) + akappa(ji,jj-1,2,1) * zu_a(ji+1,jj)
                   ze21 =   akappa(ji,jj-1,1,1) * zv_a(ji+1,jj) - akappa(ji,jj-1,1,2) * zu_a(ji+1,jj)
-                  zvis11 = 2.0 * zviseta (ji,jj-1) + dm
-                  zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
-                  zvis12 =       zviseta (ji,jj-1) + dm
-                  zvis21 =       zviseta (ji,jj-1)
+                  zvis11 = 2._wp * zviseta (ji,jj-1) + dm
+                  zvis22 =         zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+                  zvis12 =         zviseta (ji,jj-1) + dm
+                  zvis21 =         zviseta (ji,jj-1)
                   zdiag = zvis22 * ( ze11 + ze22 )
                   zs11_21 =  zvis11 * ze11 + zdiag
@@ -404,8 +396,8 @@
                   ze21 =   akappa(ji-1,jj,1,1) * ( zv_a(ji  ,jj+1) - zv_a(ji-1,jj+1) )   &
                      &   - akappa(ji-1,jj,1,2) * ( zu_a(ji  ,jj+1) + zu_a(ji-1,jj+1) )
-                  zvis11 = 2.0 * zviseta (ji-1,jj) + dm
-                  zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
-                  zvis12 =       zviseta (ji-1,jj) + dm
-                  zvis21 =       zviseta (ji-1,jj)
+                  zvis11 = 2._wp * zviseta (ji-1,jj) + dm
+                  zvis22 =         zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+                  zvis12 =         zviseta (ji-1,jj) + dm
+                  zvis21 =         zviseta (ji-1,jj)
                   zdiag = zvis22 * ( ze11 + ze22 )
                   zs11_12 =  zvis11 * ze11 + zdiag
@@ -422,8 +414,8 @@
                   ze21 =   akappa(ji,jj,1,1) * ( zv_a(ji+1,jj) + zv_a(ji+1,jj+1) - zv_a(ji  ,jj+1) )   &
                      &   - akappa(ji,jj,1,2) * ( zu_a(ji+1,jj) + zu_a(ji+1,jj+1) + zu_a(ji  ,jj+1) )
-                  zvis11 = 2.0 * zviseta (ji,jj) + dm
-                  zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
-                  zvis12 =       zviseta (ji,jj) + dm
-                  zvis21 =       zviseta (ji,jj)
+                  zvis11 = 2._wp * zviseta (ji,jj) + dm
+                  zvis22 =         zviszeta(ji,jj) - zviseta(ji,jj)
+                  zvis12 =         zviseta (ji,jj) + dm
+                  zvis21 =         zviseta (ji,jj)
                   zdiag = zvis22 * ( ze11 + ze22 )
                   zs11_22 =  zvis11 * ze11 + zdiag
@@ -441,8 +433,8 @@
                   ze21 =   akappa(ji-1,jj-1,1,1) * ( zv_a(ji  ,jj-1) - zv_a(ji-1,jj-1) - zv_a(ji-1,jj) )   &
                      &  -  akappa(ji-1,jj-1,1,2) * ( zu_a(ji  ,jj-1) + zu_a(ji-1,jj-1) + zu_a(ji-1,jj) )
-                  zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
-                  zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
-                  zvis12 =       zviseta (ji-1,jj-1) + dm
-                  zvis21 =       zviseta (ji-1,jj-1)
+                  zvis11 = 2._wp * zviseta (ji-1,jj-1) + dm
+                  zvis22 =         zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
+                  zvis12 =         zviseta (ji-1,jj-1) + dm
+                  zvis21 =         zviseta (ji-1,jj-1)
                   zdiag = zvis22 * ( ze11 + ze22 )
                   zs11_11 =  zvis11 * ze11 + zdiag
@@ -459,8 +451,8 @@
                   ze21 =   akappa(ji,jj-1,1,1) * ( zv_a(ji+1,jj-1) - zv_a(ji  ,jj-1) )   &
                      &   - akappa(ji,jj-1,1,2) * ( zu_a(ji+1,jj-1) + zu_a(ji  ,jj-1) )
-                  zvis11 = 2.0 * zviseta (ji,jj-1) + dm
-                  zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
-                  zvis12 =       zviseta (ji,jj-1) + dm
-                  zvis21 =       zviseta (ji,jj-1)
+                  zvis11 = 2._wp * zviseta (ji,jj-1) + dm
+                  zvis22 =         zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+                  zvis12 =         zviseta (ji,jj-1) + dm
+                  zvis21 =         zviseta (ji,jj-1)
                   zdiag = zvis22 * ( ze11 + ze22 )
                   zs11_21 =  zs11_21 + zvis11 * ze11 + zdiag
@@ -473,8 +465,8 @@
                   ze22 = - akappa(ji-1,jj,2,2) * zv_a(ji-1,jj) + akappa(ji-1,jj,2,1) * zu_a(ji-1,jj)
                   ze21 = - akappa(ji-1,jj,1,1) * zv_a(ji-1,jj) - akappa(ji-1,jj,1,2) * zu_a(ji-1,jj)
-                  zvis11 = 2.0 * zviseta (ji-1,jj) + dm
-                  zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
-                  zvis12 =       zviseta (ji-1,jj) + dm
-                  zvis21 =       zviseta (ji-1,jj)
+                  zvis11 = 2._wp * zviseta (ji-1,jj) + dm
+                  zvis22 =         zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+                  zvis12 =         zviseta (ji-1,jj) + dm
+                  zvis21 =         zviseta (ji-1,jj)
                   zdiag = zvis22 * ( ze11 + ze22 )
                   zs11_12 =  zs11_12 + zvis11 * ze11 + zdiag
@@ -504,12 +496,12 @@
                   zvr     = zv_a(ji,jj) - v_oce(ji,jj)
 !!!!
-                  zmod    = SQRT( zur*zur + zvr*zvr ) * ( 1.0 - zfrld(ji,jj) )
+                  zmod    = SQRT( zur*zur + zvr*zvr ) * ( 1._wp - zfrld(ji,jj) )
                   za      = rhoco * zmod
 !!!!
-!!gm chg resul    za      = rhoco * SQRT( zur*zur + zvr*zvr ) * ( 1.0 - zfrld(ji,jj) )
+!!gm chg resul    za      = rhoco * SQRT( zur*zur + zvr*zvr ) * ( 1._wp - zfrld(ji,jj) )
                   zac     = za * cangvg
                   zmpzas  = alpha * zcorl(ji,jj) + za * zsang(ji,jj)
                   zmassdt = zusdtp * zmass(ji,jj)
-                  zcorlal = ( 1.0 - alpha ) * zcorl(ji,jj)
+                  zcorlal = ( 1._wp - alpha ) * zcorl(ji,jj)
 
                   za1 =  zmassdt * zu0(ji,jj) + zcorlal * zv0(ji,jj) + za1ct(ji,jj)   &
@@ -525,5 +517,5 @@
                   zunw   = (  ( za1 + zd1 ) * zc2 + ( za2 + zd2 ) * zc1 ) * zden
                   zvnw   = (  ( za2 + zd2 ) * zb1 - ( za1 + zd1 ) * zb2 ) * zden
-                  zmask  = ( 1.0 - MAX( rzero, SIGN( rone , 1.0 - zmass(ji,jj) ) ) ) * tmu(ji,jj)
+                  zmask  = ( 1._wp - MAX( rzero, SIGN( rone , 1._wp - zmass(ji,jj) ) ) ) * tmu(ji,jj)
 
                   zu_n(ji,jj) = ( zu_a(ji,jj) + om * ( zunw - zu_a(ji,jj) ) * tmu(ji,jj) ) * zmask
@@ -580,5 +572,5 @@
 #else
    !!----------------------------------------------------------------------
-   !!   Default option          Dummy module       NO 2.0 LIM sea-ice model
+   !!   Default option        Dummy module      NO VP & LIM-2 sea-ice model
    !!----------------------------------------------------------------------
 CONTAINS
